#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h> /* close() */
#include <string.h> /* memset() */
#include<time.h>

#define LOCAL_SERVER_PORT 514
#define MAX_MSG 255

#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <syslog.h>

#include <errno.h>
#include <signal.h>

#include "utils.c"

#ifdef LINUX
  #include <mysql.h>
#else
	#include "/usr/include/mysql/mysql.h"
#endif

#define MYSQL_HOST   "localhost"       // database server name
#define MYSQL_DB     "syslog"        // database name
#define MYSQL_USERID "root"          // database user id
#define MYSQL_TABLE  "tab3"          // table name
#define MYSQL_PASSWD ""        // userid password


#define BUF_SIZE	30
#define BUF_TIME	3600

char cmdline[100000];
char buffer[500000];

char *host;
char aru[1024];
char module[255];
char level[5];
char ts[20];
char lev_num[4];

char *sal[6];
char *kal[4][7][10000];

char *buf_err[5][10000];
int ind_buf_err=0;

char ignore_aru[1000][1000];
int i,rowsa[4];

int ins;
float flevel;
int ilevel;
int dlevel;


  MYSQL mysql;
  MYSQL_RES *result;
  MYSQL_ROW row;

  unsigned int num_fields;
  int  record_count;

  char query_str[1024];
  char query_select[1024];
  char qry_str[1024];
  char *id;

int main(int argc, char *argv[]) {

int ln, pos, s1, s2, s3;

time_t aaa;
struct tm *bbb;


  int sd, rc, n, cliLen;
  struct sockaddr_in cliAddr, servAddr;
  char msg[MAX_MSG];

#ifndef LINUX
  mysql_init(&mysql);
#endif

  if (!mysql_connect(&mysql,MYSQL_HOST,MYSQL_USERID,MYSQL_PASSWD))
  {
/*     printf("Failed to connect to database: Error: %s\n",mysql_error(&mysql)); */
    return 0;
  }

  if (mysql_select_db(&mysql,MYSQL_DB)) {
/*     printf("Failed to select table: Error: %s\n",mysql_error(&mysql)); */
    mysql_close(&mysql);
    return 0;
  }

read_db();

  /* socket creation */
  sd=socket(AF_INET, SOCK_DGRAM, 0);
  if(sd<0) {
/*	printf("%s: cannot open socket \n",argv[0]); */
    exit(1);
  }

  /* bind local server port */
  servAddr.sin_family = AF_INET;
  servAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  servAddr.sin_port = htons(LOCAL_SERVER_PORT);
  rc = bind (sd, (struct sockaddr *) &servAddr,sizeof(servAddr));
  if(rc<0) {
    printf("%s: cannot bind port number %d \n", 
	   argv[0], LOCAL_SERVER_PORT);
    exit(1);
  }


  while(1) {

    
    memset(msg,0x0,MAX_MSG);


    cliLen = sizeof(cliAddr);
    n = recvfrom(sd, msg, MAX_MSG, 0, 
		 (struct sockaddr *) &cliAddr, &cliLen);

    if(n<0) {
      printf("%s: cannot receive data \n",argv[0]);
      continue;
    }

    host=inet_ntoa(cliAddr.sin_addr);
     

 
	aaa = time(NULL);
	bbb = localtime(&aaa);
	sprintf(ts, "%d%02d%02d%02d%02d%02d",1900+bbb->tm_year,bbb->tm_mon+1,bbb->tm_mday,bbb->tm_hour,bbb->tm_min,bbb->tm_sec);


ln=strlen(msg);

strcpy(module,"                                                                                                                   ");

strcpy(level,"   ");
strcpy(aru,"");

pos=0;
ins=0;

while ((pos<ln)&&(msg[pos]!='>'))
pos++;
s1=pos;

while ((pos<ln)&&(msg[pos]!=':'))
pos++;
s2=pos+2;

pos++;

while (pos<ln)
pos++;
s3=pos;

for(i=1;i<s1;i++)
level[i-1]=msg[i];

s1++;

i=s1;
while ((i<=s2-3)&&(msg[i]!='[')){
module[i-s1]=msg[i];
i++;
}

/* for(i=s1;i<=s2-3;i++)
module[i-s1]=msg[i];
*/

for(i=s2;i<=s3;i++)
aru[i-s2]=msg[i];


       strcpy(qry_str,"INSERT DELAYED INTO tab3 (host,level, TS,module, message) VALUES ('");
       strcat(qry_str,host);
       strcat(qry_str,"',");
       strcat(qry_str,level);
       strcat(qry_str,",'");
       strcat(qry_str,ts);
       strcat(qry_str,"','");
       strcat(qry_str,module);
       strcat(qry_str,"','");
       strcat(qry_str,aru);
       strcat(qry_str,"')");


       mysql_query(&mysql,qry_str);

sal[1]=host;
sal[2]=level;
sal[5]=ts;
sal[4]=module;
sal[3]=aru;

ilevel=atoi(level);
dlevel=(ilevel/8);
sprintf(lev_num,"%d",dlevel);
sal[6]=lev_num;

process();

}

mysql_close(&mysql);

return 0;

}

/*
insert the message into the error table
*/

int insert()
{
       strcpy(query_str,"INSERT DELAYED INTO tab4 (host,level, TS,module, message) VALUES ('");
       strcat(query_str,host);
       strcat(query_str,"',");
       strcat(query_str,level);
       strcat(query_str,",");
       strcat(query_str,ts);
       strcat(query_str,",'");
       strcat(query_str,module);
       strcat(query_str,"','");
       strcat(query_str,aru);
       strcat(query_str,"')");
       mysql_query(&mysql,query_str);
}

/*
process the message = look for errors
*/

int process()
{
if(tracer(1)==0)
{
if(tracer(3)==1)
do_alert();
else if (tracer(2)==1)
insert();
}
printf("NEXT\n");
}


/*
look for similar messages in buffer
insert message into the error table
call the alert program (e.g. SMS sender)
*/

int do_alert()
{

for(i=0;i<=BUF_SIZE;i++)
{

if ((buf_err[1][i]==module)&&(buf_err[2][i]==aru)&&(buf_err[3][i]==host)&&(atoi(ts)-atoi(buf_err[4][i])<BUF_TIME))
{
insert();
return(0);
}
}

buf_err[1][ind_buf_err]=module;
buf_err[2][ind_buf_err]=aru;
buf_err[3][ind_buf_err]=host;
buf_err[4][ind_buf_err]=ts;

strcat(buffer,"HOST:");
strcat(buffer, host);
strcat(buffer," TS:");
strcat(buffer, ts);
strcat(buffer," LEVEL:");
strcat(buffer, level);
strcat(buffer," MODULE:");
strcat(buffer, module);
strcat(buffer," MESSAGE:");
strcat(buffer, aru);
strcat(buffer," \n");



ind_buf_err++;
if (ind_buf_err>BUF_SIZE)
ind_buf_err=0;

insert();

sprintf(cmdline,"echo '%s'|/bin/mail -s 'ALERT' mj@globalremote.com", buffer);
my_system(cmdline);

}




/*
compare fields of the message with the content of the ignore=1, alert=2 and errors=3 tables
*/

int tracer(int act)
{
int i,ret=0;

if (act==2)
{
flevel=((ilevel/8.0)-(ilevel/8))*8;
if(flevel<5)
ret=1;
}

for(i=1;i<=rowsa[act];i++)
{
if(kal[act][1][i])
        if(!strstr(sal[1],kal[act][1][i]))
{printf("X%sX ",kal[act][1][i]);
        continue;
}
printf("OK1\n");
if(kal[act][2][i])
        if(!strstr(sal[2],kal[act][2][i]))
{printf("X%sX ",kal[act][2][i]);
        continue;
}
printf("OK2\n");

if(kal[act][3][i])
        if(!strstr(sal[3],kal[act][3][i]))
{printf("X%sX ",kal[act][3][i]);
        continue;
}
printf("OK3\n");
if(kal[act][4][i])
        if(!strstr(sal[4],kal[act][4][i]))
{printf("X%sX ",kal[act][4][i]);
        continue;
}

printf("OK4\n");
if(kal[act][5][i])
        if(!strstr(sal[5],kal[act][5][i]))
                continue;
printf("OK5\n");
if(kal[act][6][i])
        if(!strstr(sal[6],kal[act][6][i]))
                continue;
printf("finalOK\n");
ret=1;
}

if (ret==1)
{
return(1);
}
else
return(0);
}



/*
read the content of the ignore, error and alert table
*/

int read_db()
{
rowsa[1]=1;
strcpy(ignore_aru[1],"svc: unknown version (3)");
kal[1][3][1]=ignore_aru[1];

rowsa[2]=1;
strcpy(ignore_aru[2],"Cannot open");
kal[2][5][1]=ignore_aru[2];

rowsa[3]=1;
strcpy(ignore_aru[3],"root");
kal[3][3][1]=ignore_aru[3];
strcpy(ignore_aru[4],"4");
kal[3][6][1]=ignore_aru[4];

}
